<?php

namespace App\Entity;

use App\Repository\GitImageRepositoryRepository;
use Doctrine\ORM\Mapping as ORM;

#[ORM\Entity(repositoryClass: GitImageRepositoryRepository::class)]
class GitImageRepository extends AbstractEntity
{
    use NameableTrait;

    #[ORM\ManyToOne(inversedBy: 'gitImageRepositories')]
    #[ORM\JoinColumn(nullable: false)]
    private ?Image $image = null;

    #[ORM\ManyToOne(inversedBy: 'gitImageRepositories')]
    private ?ImageRepository $repository = null;

    #[ORM\Column(length: 255)]
    private ?string $status = null;

    #[ORM\Column(length: 255, nullable: true)]
    private ?string $description = null;

    #[ORM\Column(length: 255, nullable: true)]
    private ?string $branch = null;

    #[ORM\Column(length: 255)]
    private ?string $tag = null;

    #[ORM\Column(nullable: true)]
    private ?int $version = null;

    #[ORM\Column]
    private ?bool $created = null;


    public function getImage(): ?Image
    {
        return $this->image;
    }

    public function setImage(?Image $image): static
    {
        $this->image = $image;

        return $this;
    }

    public function getStatus(): ?string
    {
        return $this->status;
    }

    public function setStatus(string $status): static
    {
        $this->status = $status;

        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->description;
    }

    public function setDescription(?string $description): static
    {
        $this->description = $description;

        return $this;
    }

    public function getBranch(): ?string
    {
        return $this->branch;
    }

    public function setBranch(?string $branch): static
    {
        $this->branch = $branch;

        return $this;
    }

    public function getTag(): ?string
    {
        return $this->tag;
    }

    public function setTag(?string $tag): static
    {
        $this->tag = $tag;

        return $this;
    }

    public function getVersion(): ?int
    {
        return $this->version;
    }

    public function setVersion(?int $version): static
    {
        $this->version = $version;

        return $this;
    }

    public function isCreated(): ?bool
    {
        return $this->created;
    }

    public function setCreated(bool $created): static
    {
        $this->created = $created;

        return $this;
    }

    public function getRepository(): ?ImageRepository
    {
        return $this->repository;
    }

    public function setRepository(?ImageRepository $imageRepository): static
    {
        $this->repository = $imageRepository;

        return $this;
    }
}
